# WARNING: Please don't edit this file. It was generated by Python/WinRT v3.1.0

import datetime
import sys
import types
import typing
import uuid as _uuid
from builtins import property as _property
from abc import abstractmethod

import winrt._winrt
import winrt.system
import winrt.windows.foundation as windows_foundation
import winrt.windows.foundation.collections as windows_foundation_collections

from winrt.windows.devices.i2c.provider import ProviderI2cBusSpeed, ProviderI2cSharingMode, ProviderI2cTransferStatus

Self = typing.TypeVar('Self')

@typing.final
class ProviderI2cTransferResult:
    @_property
    def status(self) -> ProviderI2cTransferStatus: ...
    @_property
    def bytes_transferred(self) -> winrt.system.UInt32: ...
    def __new__(cls, status: ProviderI2cTransferStatus = ProviderI2cTransferStatus(0), bytes_transferred: winrt.system.UInt32 = 0) -> ProviderI2cTransferResult: ...
    def __replace__(self, /, **changes: typing.Any) -> ProviderI2cTransferResult: ...
    def unpack(self) -> typing.Tuple[ProviderI2cTransferStatus, winrt.system.UInt32]: ...

@typing.final
class ProviderI2cConnectionSettings(winrt.system.Object):
    # System.Int32 Windows.Devices.I2c.Provider.ProviderI2cConnectionSettings::get_SlaveAddress()
    @_property
    def slave_address(self) -> winrt.system.Int32: ...
    # System.Void Windows.Devices.I2c.Provider.ProviderI2cConnectionSettings::put_SlaveAddress(System.Int32)
    @slave_address.setter
    def slave_address(self, value: winrt.system.Int32) -> None: ...
    # Windows.Devices.I2c.Provider.ProviderI2cSharingMode Windows.Devices.I2c.Provider.ProviderI2cConnectionSettings::get_SharingMode()
    @_property
    def sharing_mode(self) -> ProviderI2cSharingMode: ...
    # System.Void Windows.Devices.I2c.Provider.ProviderI2cConnectionSettings::put_SharingMode(Windows.Devices.I2c.Provider.ProviderI2cSharingMode)
    @sharing_mode.setter
    def sharing_mode(self, value: ProviderI2cSharingMode) -> None: ...
    # Windows.Devices.I2c.Provider.ProviderI2cBusSpeed Windows.Devices.I2c.Provider.ProviderI2cConnectionSettings::get_BusSpeed()
    @_property
    def bus_speed(self) -> ProviderI2cBusSpeed: ...
    # System.Void Windows.Devices.I2c.Provider.ProviderI2cConnectionSettings::put_BusSpeed(Windows.Devices.I2c.Provider.ProviderI2cBusSpeed)
    @bus_speed.setter
    def bus_speed(self, value: ProviderI2cBusSpeed) -> None: ...

@typing.final
class _II2cControllerProvider: ...

class II2cControllerProvider(winrt._winrt.IInspectable):
    # Windows.Devices.I2c.Provider.II2cDeviceProvider Windows.Devices.I2c.Provider.II2cControllerProvider::GetDeviceProvider(Windows.Devices.I2c.Provider.ProviderI2cConnectionSettings)
    @abstractmethod
    def get_device_provider(self, settings: ProviderI2cConnectionSettings, /) -> II2cDeviceProvider: ...

@typing.final
class _II2cDeviceProvider: ...

class II2cDeviceProvider(windows_foundation.IClosable, winrt._winrt.IInspectable):
    # System.Void Windows.Devices.I2c.Provider.II2cDeviceProvider::Read(System.Byte[])
    @abstractmethod
    def read(self, buffer: typing.Union[winrt.system.Array[winrt.system.UInt8], winrt.system.WriteableBuffer], /) -> None: ...
    # Windows.Devices.I2c.Provider.ProviderI2cTransferResult Windows.Devices.I2c.Provider.II2cDeviceProvider::ReadPartial(System.Byte[])
    @abstractmethod
    def read_partial(self, buffer: typing.Union[winrt.system.Array[winrt.system.UInt8], winrt.system.WriteableBuffer], /) -> ProviderI2cTransferResult: ...
    # System.Void Windows.Devices.I2c.Provider.II2cDeviceProvider::Write(System.Byte[])
    @abstractmethod
    def write(self, buffer: typing.Union[winrt.system.Array[winrt.system.UInt8], winrt.system.ReadableBuffer], /) -> None: ...
    # Windows.Devices.I2c.Provider.ProviderI2cTransferResult Windows.Devices.I2c.Provider.II2cDeviceProvider::WritePartial(System.Byte[])
    @abstractmethod
    def write_partial(self, buffer: typing.Union[winrt.system.Array[winrt.system.UInt8], winrt.system.ReadableBuffer], /) -> ProviderI2cTransferResult: ...
    # System.Void Windows.Devices.I2c.Provider.II2cDeviceProvider::WriteRead(System.Byte[],System.Byte[])
    @abstractmethod
    def write_read(self, write_buffer: typing.Union[winrt.system.Array[winrt.system.UInt8], winrt.system.ReadableBuffer], read_buffer: typing.Union[winrt.system.Array[winrt.system.UInt8], winrt.system.WriteableBuffer], /) -> None: ...
    # Windows.Devices.I2c.Provider.ProviderI2cTransferResult Windows.Devices.I2c.Provider.II2cDeviceProvider::WriteReadPartial(System.Byte[],System.Byte[])
    @abstractmethod
    def write_read_partial(self, write_buffer: typing.Union[winrt.system.Array[winrt.system.UInt8], winrt.system.ReadableBuffer], read_buffer: typing.Union[winrt.system.Array[winrt.system.UInt8], winrt.system.WriteableBuffer], /) -> ProviderI2cTransferResult: ...
    # System.String Windows.Devices.I2c.Provider.II2cDeviceProvider::get_DeviceId()
    @_property
    @abstractmethod
    def device_id(self) -> str: ...

@typing.final
class _II2cProvider: ...

class II2cProvider(winrt._winrt.IInspectable):
    # Windows.Foundation.IAsyncOperation`1<Windows.Foundation.Collections.IVectorView`1<Windows.Devices.I2c.Provider.II2cControllerProvider>> Windows.Devices.I2c.Provider.II2cProvider::GetControllersAsync()
    @abstractmethod
    def get_controllers_async(self) -> windows_foundation.IAsyncOperation[typing.Sequence[II2cControllerProvider]]: ...

